package hr.fer.bachelorThesis;


import hr.fer.bachelorThesis.gui.GUIController;
import hr.fer.bachelorThesis.gui.MainWindow;
import hr.fer.bachelorThesis.gui.WindowBuilder;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.stage.Stage;
/**
 * Entry point to the labyrinth simulation program.
 * @author Viran
 *
 */
public class Main extends Application {

	static private Stage stage;
	private static MainWindow mywindow=new MainWindow(
			new GUIController(),
			new WindowBuilder()
		);
	
	public static void main(String[] args) {
		launch();
	}

	@Override
	public void start(Stage primaryStage) throws Exception {
		//System.err.println("Swarm algorithm toolkit - Labyrinth exploration... Starting");
		stage = primaryStage;
		stage.setOnCloseRequest(e -> closeProgram());
		stage.setTitle("Labyrinth optimisation");
		stage.setResizable(false);
		stage.setScene(new Scene(mywindow.getWindow()));
		stage.show();
	}

	/**
	 * Method used to properly finish the simulation
	 */
	private void closeProgram() {
		stage.close();
		Runtime.getRuntime().halt(0);
	}
}
