package hr.fer.bachelorThesis.algorithm;

import hr.fer.bachelorThesis.algorithm.memory.ITargetSystemMemory;
import hr.fer.bachelorThesis.gui.labyrinth.LabyrinthView;

public interface IAlgorithmManager {

	IAlgorithm getAlgorithm();

	IAlgorithmDrawer getAlgorithmDrawer();

	void startAlgorithm();

	void pauseAlgorithm();

	void resumeAlgorithm();

	void stopAlgorithm();

	void setSharedMemory(IAlgorithmManager firstManager);
	
	ITargetSystemMemory getSharedMemory();

	void setLabyrinthView(LabyrinthView labyrinthView, double agentDim);

	boolean drawingBufferEmpty();

	void prepareNextIteration();

	boolean isDone();

	void shouldDisplayMemory(boolean selected);
	

}
