package hr.fer.bachelorThesis.algorithm;

import java.util.Collection;

import hr.fer.bachelorThesis.algorithm.pso.IAgent;
import hr.fer.bachelorThesis.util.linearAlgebra.IVector;

public interface IPopulation {
	
	public Collection<IAgent> getAgentNeighbours(IAgent agent);
	
	public Iterable<IAgent> allAgentsIterable();
	
	public Iterable<IAgent> unfinishedAgentsIterable();
	
	public IAgent globalBestAgent();
	
	public void refreshPopulationState();
	
	public IVector getPopVector();

	public int numberOfAgents();
	
	public IVector getCenterPosition();

//	public double getMinDistFromCenver();
//
//	public double getMaxDistFromCenver() ;
	
}
