package hr.fer.bachelorThesis.algorithm.memory;

public interface IMemoryElement {

	
	/**
	 * Get type of element at this location.
	 * @return Element type.
	 */
	public EMemoryElement getElement();
	
	/**
	 * Get number of passes over this location.
	 * @return Number of particles passed over this location.
	 */
	public int getNumOfPartPassed();
	
	/**
	 * Increment this position's passed value.
	 */
	public void incPass();
	
	/**
	 * Assign a new element to this map component.
	 * @param element New element type.
	 */
	public void setElement(EMemoryElement element);
	
	/**
	 * Calculate the score for this position.
	 * @return Position score.
	 */
	double calculatePositionScore();

	String stringLabel();
}
