package hr.fer.bachelorThesis.algorithm.stopCondition;

import hr.fer.bachelorThesis.algorithm.IPopulation;
import hr.fer.bachelorThesis.algorithm.pso.IAgent;

public class ExitFoundCondition implements IStopCondition{

	private IPopulation population;
	private int exitFoundNumber;
	private int iterations;

	public ExitFoundCondition(IPopulation population, int exitFoundNumber) {
		this.population=population;
		if(exitFoundNumber<0) exitFoundNumber=0;
		if(exitFoundNumber>population.numberOfAgents()) exitFoundNumber=population.numberOfAgents();
		this.exitFoundNumber=exitFoundNumber;
	}
	
	@Override
	public boolean isDone() {
		int currentlyAtExit=0;
		for(IAgent agent:population.allAgentsIterable()){
			if(agent.getIsFinished())
				currentlyAtExit++;
			
			if(currentlyAtExit>=exitFoundNumber)
				return true;
		}
		return false;
	}

	@Override
	public void iterationPassed() {
		// TODO Auto-generated method stub
		this.iterations++;
	}

	@Override
	public void initialise() {
		// TODO Auto-generated method stub
		this.iterations=0;
	}

	@Override
	public int getCurrentIteration() {
		return this.iterations;
	}


}
