package hr.fer.bachelorThesis.algorithm.stopCondition;

import hr.fer.bachelorThesis.algorithm.IPopulation;
import javafx.geometry.Insets;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.RowConstraints;

public class IterationsForm extends StopConditionInputPane {

	// variables
	static private final int maxIterations = 1_000;

	// graphical components
	private TextField maxIterationsInput;

	private GridPane layout;

	public IterationsForm() {
		this.layout = new GridPane();
		this.getChildren().add(this.layout);
		initialise();
	}

	private void initialise() {
//		this.setPrefWidth(300);
//		this.setPadding(new Insets(8));
//
//		int numberOfColumns = 2;
//		for (int i = 0; i < numberOfColumns; i++) {
//			ColumnConstraints column = new ColumnConstraints();
//			column.setPercentWidth(100 / numberOfColumns);
//			this.layout.getColumnConstraints().add(column);
//		}
//
//		int numberOfRows = 6;
//		for (int i = 0; i < numberOfRows; i++) {
//			RowConstraints row = new RowConstraints();
//			row.setPercentHeight(100 / numberOfRows);
//			this.layout.getRowConstraints().add(row);
//		}

		this.layout.add(new Label("Maximal iterations: "), 0, 0);
		maxIterationsInput = new TextField();
		maxIterationsInput.setText(String.valueOf(maxIterations));
		this.layout.add(maxIterationsInput, 1, 0);

	}

	public int getMaxIterations() {
		return Integer.parseInt(maxIterationsInput.getText());
	}

	@Override
	public IStopCondition generateStopCondition(IPopulation populatio) {
		return new IterationStopCondition(this.getMaxIterations());
	}

}
