package hr.fer.bachelorThesis.algorithm.stopCondition;

public class TimePassedCondition implements IStopCondition {

	private long durationTime;
	private int iterations;
	private long startTime;

	public TimePassedCondition(long durationTime) {
		this.durationTime=durationTime;
		this.iterations=0;
	}

	@Override
	public boolean isDone() {
		long currentTime=System.nanoTime();
		if(startTime+durationTime<=currentTime) return true;
		else return false;
	}

	@Override
	public void iterationPassed() {
		this.iterations++;
	}

	@Override
	public void initialise() {
		this.startTime=System.nanoTime();
	}

	@Override
	public int getCurrentIteration() {
		return this.iterations;
	}
}
