package hr.fer.bachelorThesis.algorithm.stopCondition;

import hr.fer.bachelorThesis.algorithm.IPopulation;
import javafx.geometry.Insets;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.RowConstraints;

public class TimerForm extends StopConditionInputPane {

	// variables
	static private final int minutesDuration = 1;
	static private final int secondsDuration = 0;

	// graphical components
	private TextField minutesDurationInput;
	private TextField secondsDurationInput;

	private GridPane layout;

	public TimerForm() {
		this.layout = new GridPane();
		this.getChildren().add(this.layout);
		initialise();
	}

	private void initialise() {
//		this.setPrefWidth(300);
//		this.setPadding(new Insets(8));
//
//		int numberOfColumns = 2;
//		for (int i = 0; i < numberOfColumns; i++) {
//			ColumnConstraints column = new ColumnConstraints();
//			column.setPercentWidth(100 / numberOfColumns);
//			this.layout.getColumnConstraints().add(column);
//		}
//
//		int numberOfRows = 6;
//		for (int i = 0; i < numberOfRows; i++) {
//			RowConstraints row = new RowConstraints();
//			row.setPercentHeight(100 / numberOfRows);
//			this.layout.getRowConstraints().add(row);
//		}

		this.layout.add(new Label("Duration in minutes: "), 0, 0);
		minutesDurationInput = new TextField();
		minutesDurationInput.setText(String.valueOf(minutesDuration));
		this.layout.add(minutesDurationInput, 1, 0);

		this.layout.add(new Label("Duraition in seconds: "), 0, 1);
		secondsDurationInput = new TextField();
		secondsDurationInput.setText(String.valueOf(secondsDuration));
		this.layout.add(secondsDurationInput, 1, 1);

	}

	public long getDuretionTimeNano() {
		int minutes = Integer.parseInt(minutesDurationInput.getText());
		int seconds = Integer.parseInt(secondsDurationInput.getText());
		minutes += seconds / 60;
		seconds %= 60;
		return (minutes * 60_000_000_000L) + (seconds * 1_000_000_000L);
	}

	@Override
	public IStopCondition generateStopCondition(IPopulation populatio) {
		return new TimePassedCondition(this.getDuretionTimeNano());
	}

}
