package hr.fer.bachelorThesis.algorithm.strategy;

import hr.fer.bachelorThesis.algorithm.IPopulation;
import hr.fer.bachelorThesis.algorithm.pso.IAgent;
import hr.fer.bachelorThesis.util.linearAlgebra.IVector;
import hr.fer.bachelorThesis.util.linearAlgebra.IncompatibleOperandException;

public class PopulationDirectionStrategy implements IAgentStrategy {

	private IAgentStrategy strategy;
	private IPopulation population;
	private double maxVectorSize;

	public PopulationDirectionStrategy(IAgentStrategy strategy, IPopulation population, double maxVectorSize) {
		this.strategy=strategy;
		this.population=population;
		this.maxVectorSize=maxVectorSize;
	}
	
	@Override
	public IVector nextDirectionVector(IAgent agent) throws IncompatibleOperandException {
		IVector dirVector=population.getPopVector();
		if(dirVector.norm()>maxVectorSize)
			dirVector.normalise().scalarMultiply(maxVectorSize);
		//System.out.println("Population dir vector: "+dirVector);
		return dirVector.add(strategy.nextDirectionVector(agent));
	}

	

}
