package hr.fer.bachelorThesis.gui;

import javafx.scene.layout.GridPane;

/**
 * Main window used in labyrinth simulation program.
 * @author Viran
 *
 */
public class MainWindow {

	/**
	 * The controller class responsible for this window.
	 */
	private IGUIController guiController;
	
	/**
	 * Components of this window contained in a grid.
	 */
	private static GridPane windowGrid;
	
	/**
	 * Assignees a controller to this window
	 * @param guiController
	 */
	public MainWindow(IGUIController guiController, WindowBuilder windowBuilder) {
		this.guiController=guiController;
		windowGrid=windowBuilder.buildWindow(guiController);
	}
	
	/**
	 * Get this window panel 
	 * @return This window layout as a gridPane object.
	 */
	public GridPane getWindow(){
		return windowGrid;
	}
	
	/**
	 * Get the controller for this window.
	 * @return Graphical user interface controller object.
	 */
	public IGUIController getGuiController(){
		return this.guiController;
	}
	
	
}
