package hr.fer.bachelorThesis.gui.algorithm;

import java.util.List;

import hr.fer.bachelorThesis.algorithm.IAlgorithmManager;
import hr.fer.bachelorThesis.gui.control.ConfigurationPane;
import hr.fer.bachelorThesis.gui.control.StopConditionPane;
import hr.fer.bachelorThesis.labyrinth.ILabyrinth;
import javafx.scene.control.Accordion;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonBar;
import javafx.scene.control.TitledPane;
import javafx.scene.layout.GridPane;

public class AlgorithmConfigurationPane extends TitledPane {

	private static GridPane layout = new GridPane();
	private AlgorithmPane algorithmPane;
	private StopConditionPane stopConditionPane;
	
	public AlgorithmConfigurationPane(ConfigurationPane configurationPane) {
		super("Algorithm configuration", layout);
		this.getChildren().add(layout);
		buildAlgConfPane(layout, configurationPane);
	}

	private void buildAlgConfPane(GridPane layout, ConfigurationPane configurationPane) {
		Accordion accordition = new Accordion();
		layout.add(accordition, 0, 0);
		
		this.stopConditionPane= new StopConditionPane(configurationPane);
		this.algorithmPane = new AlgorithmPane(configurationPane,this.stopConditionPane);
		
		accordition.getPanes().addAll(algorithmPane,stopConditionPane);

		
		
	}

	
	public void setLabyrinth(ILabyrinth labyrinth) {
		this.algorithmPane.setLabyrinth(labyrinth);
		
	}

	public List<IAlgorithmManager> getAlgorithmManagers() {
		return this.algorithmPane.getAlgorithmManagers();
	}

}
