package hr.fer.bachelorThesis.gui.control;

import hr.fer.bachelorThesis.gui.IGUIController;
import hr.fer.bachelorThesis.gui.algorithm.AlgorithmConfigurationPane;
import hr.fer.bachelorThesis.gui.labyrinth.LabyrinthPane;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Node;
import javafx.scene.control.Accordion;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonBar;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Pane;
import javafx.scene.layout.RowConstraints;

public class PausedPane extends Pane{

	public PausedPane(IGUIController guiController) {
		this.getChildren().add(setupDisplay(guiController));
	}

	private Node setupDisplay(IGUIController guiController) {
		// System.err.println("Building setup view");
		GridPane layout = new GridPane();
		//styleSetupDisplay(layout);
		
		ButtonBar buttonBar = new ButtonBar();

		Button pauseSimButton = new Button("Resume simulation");
		buttonBar.getButtons().add(pauseSimButton);
		layout.add(buttonBar, 0, 0);

		pauseSimButton.setOnAction(new EventHandler<ActionEvent>() {

			@Override
			public void handle(ActionEvent event) {
				guiController.resumeSimulation();
			}
		});
		
		Button resumeSimButton = new Button("Stop simulation");
		buttonBar.getButtons().add(resumeSimButton);
		

		resumeSimButton.setOnAction(new EventHandler<ActionEvent>() {

			@Override
			public void handle(ActionEvent event) {
				guiController.stopSimulation();
			}
		});
		

		return layout;
	}

	private void styleSetupDisplay(GridPane layout) {
		// add one column
		ColumnConstraints column1 = new ColumnConstraints();
		layout.getColumnConstraints().add(column1);
		// add two rows
		RowConstraints row1 = new RowConstraints();
		row1.setPercentHeight(80);
		layout.getRowConstraints().add(row1);
		RowConstraints row2 = new RowConstraints();
		row2.setPercentHeight(20);
		layout.getRowConstraints().add(row2);

	}
}
