package hr.fer.bachelorThesis.gui.control;

import hr.fer.bachelorThesis.algorithm.IPopulation;
import hr.fer.bachelorThesis.algorithm.stopCondition.IStopCondition;
import hr.fer.bachelorThesis.algorithm.stopCondition.StopConditionFactory;
import hr.fer.bachelorThesis.algorithm.stopCondition.StopConditionInputPane;
import hr.fer.bachelorThesis.gui.ProgramGeneralConstants;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TitledPane;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.RowConstraints;

public class StopConditionPane extends TitledPane {

	private static GridPane layout = new GridPane();
	private StopConditionInputPane selectedPane;
	
	
	public StopConditionPane(ConfigurationPane configurationPane) {
		super("Stop condition", layout);
		buildStopCondPane(this, configurationPane);
		selectedPane=StopConditionFactory.getStopConditonForm(ProgramGeneralConstants.STOP_CONDITION_LABELS[2]);
		layout.add(selectedPane,0,1);
	}

	private void buildStopCondPane(StopConditionPane stopConditionPane, ConfigurationPane configurationPane) {
		//styleStopCondPane(layout);

		stopConditionPane.setExpanded(false);
		stopConditionPane.setCollapsible(true);

		ComboBox<String> selGenComboBox = new ComboBox<>();
		selGenComboBox.getItems().addAll(ProgramGeneralConstants.STOP_CONDITION_LABELS);
		selGenComboBox.setValue(ProgramGeneralConstants.STOP_CONDITION_LABELS[2]);
		selGenComboBox.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent event) {
				// Provide parameters form
				String selectedGenerator = selGenComboBox.getSelectionModel().getSelectedItem();

				if(selectedPane!=null)
					layout.getChildren().remove(selectedPane);
				selectedPane=StopConditionFactory.getStopConditonForm(selectedGenerator);
				layout.add(selectedPane,0,1);
			}
		});
		layout.add(selGenComboBox, 0, 0);
	}
	
	public IStopCondition generateStopCondition(IPopulation population){
		return selectedPane.generateStopCondition(population);
	}

}
