package hr.fer.bachelorThesis.gui.labyrinth;

import hr.fer.bachelorThesis.gui.ProgramGeneralConstants;
import hr.fer.bachelorThesis.gui.control.ConfigurationPane;
import hr.fer.bachelorThesis.labyrinth.ILabyrinth;
import hr.fer.bachelorThesis.labyrinth.LabyrinthFactory;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonBar;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TitledPane;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Pane;
import javafx.scene.layout.RowConstraints;

public class LabyrinthPane extends TitledPane {
	
	private static GridPane layout = new GridPane();
	private Pane laybrinthForm;
	
	public LabyrinthPane(ConfigurationPane configurationPane) {
		super("Labyrinth generator", layout);
		buildLabGeneratorPane(this,configurationPane);
		
	}

	private void buildLabGeneratorPane(LabyrinthPane labyrinthPane, ConfigurationPane configurationPane) {
		//styleLabGeneratorPane(layout);
		
		labyrinthPane.setExpanded(true);
		labyrinthPane.setCollapsible(true);
		
		ComboBox<String> selGenComboBox = new ComboBox<>();
		selGenComboBox.getItems().addAll(ProgramGeneralConstants.LABYRINTH_GENERATOR_LABELS);
		selGenComboBox.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent event) {
				//Provide parameters form
				//System.err.println("Labyrinth generator action: selected layrinth");
				String selectedGenerator=selGenComboBox.getSelectionModel().getSelectedItem();
				
				layout.getChildren().remove(laybrinthForm);
				
				laybrinthForm=LabyrinthFactory.getLabyrinthForm(selectedGenerator);
				layout.add(laybrinthForm, 0, 1);
			}
		});
		layout.add(selGenComboBox, 0, 0);

		
		ButtonBar genButtonBar=new ButtonBar();
		Button selectGenerator=new Button("Select generator");
		genButtonBar.getButtons().add(selectGenerator);
		selectGenerator.setOnAction((event)->{
			//CHANGES TO LAYOUT AFFECT THIS CODE.

			//Node formNode=layout.getChildren().get(layout.getChildren().size()-1);
			if(laybrinthForm!=null){
				ILabyrinth labyrinth = LabyrinthFactory.setParametersAndGenerate(laybrinthForm, configurationPane.getCanvasDimension());
				configurationPane.setLabyrinthSelected(labyrinth);
			}
		});
		layout.add(genButtonBar, 0, 2);
		
	}


	private void styleLabGeneratorPane(GridPane layout) {
		//add one column
				ColumnConstraints column1 = new ColumnConstraints();
				layout.getColumnConstraints().add(column1);
				// add three rows
				RowConstraints row1 = new RowConstraints();
				row1.setPercentHeight(20);
				layout.getRowConstraints().add(row1);
				
				RowConstraints row2 = new RowConstraints();
				row2.setPercentHeight(60);
				layout.getRowConstraints().add(row2);
				
				RowConstraints row3 = new RowConstraints();
				row3.setPercentHeight(20);
				layout.getRowConstraints().add(row3);
		
	}

}
