package hr.fer.bachelorThesis.labyrinth;

import hr.fer.bachelorThesis.labyrinth.LabyrinthElement;

/**
 * EnumCodomain element wrapper as seen in labyrinth domain matrix.
 * @author Viran
 *
 */
public class LabyrinthElement {
	private ELabyrinthElement element;
	
	/**
	 * EnumCodomain constructor;
	 * @param element Assigned element to this 
	 */
	public LabyrinthElement (ELabyrinthElement element) {
		this.element = element;
	}
	
	/**
	 * Get this element.
	 * @return This element.
	 */
	public ELabyrinthElement get() {
		return element;
	}
	
	/**
	 * Set value for this element.
	 * @param element Set element.
	 */
	public void set(ELabyrinthElement element) {
		this.element = element;
	}
	
	/**
	 * Compare this element to other EnumCodomain element.
	 * @param other Comparing element.
	 * @return True if equal, false otherwise.
	 */
	@Override
	public boolean equals(Object other){
		if(other instanceof ELabyrinthElement){
			ELabyrinthElement otherE=(ELabyrinthElement) other;
			return element.equals(otherE);
		}
		else if(other instanceof LabyrinthElement){
			LabyrinthElement otherE=(LabyrinthElement)other;
			return element.equals(otherE.element);
		}
		return false;
	}
	
	@Override
	public String toString() {
		switch(element){
		case EXIT: return"EXIT";
		case PASSABLE: return"PASSABLE"; 
		case WALL: return"WALL"; 
		case START: return"START"; 
		default : return "Error:Unknown";
		}
	}
}
