package hr.fer.bachelorThesis.labyrinth;

import hr.fer.bachelorThesis.gui.ProgramGeneralConstants;
import hr.fer.bachelorThesis.gui.labyrinth.FELabForm;
import hr.fer.bachelorThesis.labyrinth.generator.FixedEntranceLabyrinthGenerator;
import hr.fer.bachelorThesis.labyrinth.generator.FixedEntranceLabyrinthGenerator2;
import hr.fer.bachelorThesis.labyrinth.generator.RadialAttractionStrategy;
import hr.fer.bachelorThesis.labyrinth.generator.WallDeletingComplexityModifier;
import javafx.scene.Node;
import javafx.scene.control.TextArea;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Pane;
import javafx.scene.layout.RowConstraints;

public class LabyrinthFactory {

	public static Pane getLabyrinthForm(String selectedGenerator) {
		if (selectedGenerator.equals(ProgramGeneralConstants.LABYRINTH_GENERATOR_LABELS[0])) {
			return new FELabForm();
		} else {
			Pane pane=new Pane();
			GridPane grid = new GridPane();

			// add one column
			ColumnConstraints column1 = new ColumnConstraints();
			grid.getColumnConstraints().add(column1);
			// add two rows
			RowConstraints row1 = new RowConstraints();
			grid.getRowConstraints().add(row1);

			grid.add(
					new TextArea(
							"There was an error selecting the labyrinth generator.\nPlease try again a different option."),
					0, 0);
			pane.getChildren().add(grid);
			return grid;
		}
	}

	public static ILabyrinth setParametersAndGenerate(Node selectedGeneratorNode, int canvasDimension) {
		if (selectedGeneratorNode instanceof FELabForm) {
			FELabForm form = (FELabForm) selectedGeneratorNode;
			Labyrinth labyrinth = new Labyrinth(form.getLabyrinthSizeInput(), canvasDimension,
					new FixedEntranceLabyrinthGenerator2(form.getEntranceLabelInput(), form.getNumberOfExitsInput(), form.getCorridorWidthInput()),
					new WallDeletingComplexityModifier(form.getComplexityInput(),
							ProgramGeneralConstants.EXIT_PROTECTION_RADIUS),
					new RadialAttractionStrategy(ProgramGeneralConstants.RADIAL_ATTRACTION_STRATEGY_RADIUS));
			
			return labyrinth;

		} else {
			return null;
		}

	}
}
