package hr.fer.bachelorThesis.labyrinth.generator;

import hr.fer.bachelorThesis.labyrinth.Labyrinth;
import hr.fer.bachelorThesis.util.linearAlgebra.IVector;
import hr.fer.bachelorThesis.util.linearAlgebra.Vector;

public class RadialAttractionStrategy implements IExitAttractionStrategy {

	private int diameter;

	public RadialAttractionStrategy(int diameter) {
		this.diameter = diameter;
	}

	@Override
	public boolean exitInfluenceSignificant(int x, int y, Labyrinth labyrinth) {
		IVector testVector = new Vector(0, 0);

		for (int i = -diameter; i <= +diameter; i++) {
			for (int j = -diameter; j <= +diameter; j++) {

				if (labyrinth.isFinished(testVector.set(0, x + i).set(1, y + j)))
					return true;

			}
		}

		return false;
	}

}
